unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ScktComp, winsock, ComCtrls, Grids, Menus, INIFiles, gnutellatrans,
  ExtCtrls;

type
  TfrmMain = class(TForm)
    Memo1: TMemo;
    tvwNav: TTreeView;
    pgcMain: TPageControl;
    tabGnuTellaNet: TTabSheet;
    edtHost: TEdit;
    btnConnect: TButton;
    btnRemoveClient: TButton;
    Label1: TLabel;
    memConnections: TMemo;
    Label2: TLabel;
    memStats: TMemo;
    btnUpdateStats: TButton;
    Label3: TLabel;
    tabUploads: TTabSheet;
    Label4: TLabel;
    tabDownloads: TTabSheet;
    Label5: TLabel;
    tabSearch: TTabSheet;
    edtSearch: TEdit;
    btnSearch: TButton;
    tabSrchMon: TTabSheet;
    chkSearchMonitor: TCheckBox;
    Label6: TLabel;
    edtSrchCount: TEdit;
    Label7: TLabel;
    memSearchMon: TMemo;
    tabConfig: TTabSheet;
    Label8: TLabel;
    lblSearchResults: TLabel;
    Label9: TLabel;
    edtMinSpeed: TEdit;
    btnDownload: TButton;
    lvwSrchRes: TListView;
    btnStream: TButton;
    GroupBox1: TGroupBox;
    Label10: TLabel;
    edtTotalMessages: TEdit;
    Label11: TLabel;
    edtSearches: TEdit;
    edtRouteErrs: TEdit;
    edtDropped: TEdit;
    edtUploadCnt: TEdit;
    edtDownloadCnt: TEdit;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    lstHostCatcher: TListBox;
    Label17: TLabel;
    edtTryToKeep: TEdit;
    Label18: TLabel;
    btnAdd: TButton;
    lvwConnections: TListView;
    Label19: TLabel;
    btnRemoveHostcatch: TButton;
    btnClearHostCatch: TButton;
    btnGetMore: TButton;
    pumLog: TPopupMenu;
    mniClearLog: TMenuItem;
    lvwUploads: TListView;
    Button1: TButton;
    Button3: TButton;
    chkAutoClearUL: TCheckBox;
    lvwDownloads: TListView;
    ListView1: TListView;
    Button4: TButton;
    Label20: TLabel;
    btnAbortDL: TButton;
    btnResumeDL: TButton;
    btnClearDL: TButton;
    Label21: TLabel;
    edtMaxDL: TEdit;
    chkAutoClearDL: TCheckBox;
    chkLog: TCheckBox;
    Label22: TLabel;
    tmrUpdteNetInfo: TTimer;
    GroupBox2: TGroupBox;
    edtConnectionSpeed: TEdit;
    Label23: TLabel;
    chkThrottle: TCheckBox;
    GroupBox3: TGroupBox;
    Label24: TLabel;
    edtListenPort: TEdit;
    btnUpdateListenPort: TButton;
    lblCurrentPort: TLabel;
    GroupBox4: TGroupBox;
    Label25: TLabel;
    Label26: TLabel;
    edtMaxTTL: TEdit;
    edtMyTTL: TEdit;
    GroupBox5: TGroupBox;
    chkForceLocalIP: TCheckBox;
    edtLocalIP: TEdit;
    gtt: TGnutellaTrans;
    procedure btnConnectClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure tvwNavChange(Sender: TObject; Node: TTreeNode);
    procedure edtSrchCountChange(Sender: TObject);
    procedure chkSearchMonitorClick(Sender: TObject);
    procedure btnDownloadClick(Sender: TObject);
    procedure btnSearchClick(Sender: TObject);
    procedure btnUpdateStatsClick(Sender: TObject);
    procedure btnRemoveHostcatchClick(Sender: TObject);
    procedure btnClearHostCatchClick(Sender: TObject);
    procedure mniClearLogClick(Sender: TObject);
    procedure edtSearchKeyPress(Sender: TObject; var Key: Char);
    procedure btnAddClick(Sender: TObject);
    procedure gttLogStatus(Sender: TObject; const s: String);
    procedure gttClientCreated(CInfo: TGConnection);
    procedure gttClientConnected(CInfo: TGConnection);
    procedure gttInitResponse(const HostIP: String; HostPort: Word;
      FileCnt, FileSize: Integer);
    procedure gttSearchReq(MinSpeed: Word; const Search: String);
    procedure gttSrchRespItem(FileIdx, FileSize, HostSpeed: Integer;
      const FileName: String);
    procedure gttClientDisconnect(CInfo: TGConnection);
    procedure tmrUpdteNetInfoTimer(Sender: TObject);
    procedure btnUpdateListenPortClick(Sender: TObject);
    procedure edtListenPortChange(Sender: TObject);
    procedure edtConnectionSpeedChange(Sender: TObject);
    procedure edtMaxTTLChange(Sender: TObject);
    procedure edtMyTTLChange(Sender: TObject);
    procedure edtLocalIPChange(Sender: TObject);
    procedure chkForceLocalIPClick(Sender: TObject);
    procedure gttClientProtocolConnect(CInfo: TGConnection);
    procedure gttCatchHost(Sender: TObject; const s: String);
    procedure gttListenPortInUse(Sender: TObject);
    procedure btnRemoveClientClick(Sender: TObject);
    procedure DoTryNKeep;
    procedure edtTryToKeepChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    iSrchMonMax:    integer;
    iSrchResults:   integer;
    FS:         TFileStream;

    procedure UpdateSearchResultsCnt;
    procedure UpdateOneConnectionInfo(CInfo : TGConnection; const Stat : string);
  public
    procedure Log(const s: string);
    procedure UpdateConnections;
    procedure UpdateGTNStats;
    procedure LoadSettings;
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.btnConnectClick(Sender: TObject);
begin
  if lstHostCatcher.ItemIndex <> -1 then
    gtt.ConnectNewHost(lstHostCatcher.Items[lstHostCatcher.ItemIndex]);
end;

procedure TfrmMain.Log(const s: string);
begin
  if chkLog.Checked then begin
    Memo1.Lines.Add(s);
    if Assigned(FS) then
      FS.Write(PChar(s+#13#10)^, Length(s)+2);
  end;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FS.Free;
  FS := nil;

  lstHostCatcher.Items.SaveToFile('gnutella.NET');

  gtt.Shutdown;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Randomize;
  LoadSettings;

  // FS := TFileStream.Create('C:\gnutella.log', fmCreate or fmShareDenyWrite);
  tvwNav.FullExpand;
  UpdateConnections;
  UpdateGTNStats;
  tvwNav.Selected := tvwNav.Items.GetFirstNode;
  pgcMain.ActivePage := tabGnuTellaNet;
  edtSrchCountChange(edtSrchCount);
  edtConnectionSpeedChange(edtConnectionSpeed);
  edtMyTTLChange(edtMyTTL);
  edtMaxTTLChange(edtMaxTTL);
  edtLocalIPChange(edtLocalIP);
    { this will start us listening too }
  btnUpdateListenPortClick(btnUpdateListenPort);

  if FileExists('GNUTELLA.NET') then
    lstHostCatcher.Items.LoadFromFile('GNUTELLA.NET');
end;

procedure TfrmMain.UpdateConnections;
begin
  memConnections.Text := Format(
    '%d gnutellaNet'#13#10 +
    '%d uploads'#13#10 +
    '%d downloads',
    [gtt.ConnectionCount, 0, 0]);
end;

procedure TfrmMain.UpdateGTNStats;
begin
  memStats.Text := Format(
    '%u hosts'#13#10 +
    '%u files'#13#10 +
    '%u MB'#13#10 +
    '%ums avg ping',
    [gtt.GTNHosts, gtt.GTNFiles, gtt.GTNSize, gtt.GTNAvgPing]);
end;

procedure TfrmMain.tvwNavChange(Sender: TObject; Node: TTreeNode);
begin
  case Node.ImageIndex of
    0:  pgcMain.ActivePage := tabGnuTellaNet;
    1:  pgcMain.ActivePage := tabUploads;
    2:  pgcMain.ActivePage := tabDownloads;
    3:  pgcMain.ActivePage := tabSearch;
    4:  pgcMain.ActivePage := tabSrchMon;
    5:  pgcMain.ActivePage := tabConfig;
  end;
end;

procedure TfrmMain.edtSrchCountChange(Sender: TObject);
begin
  iSrchMonMax := StrToIntDef(edtSrchCount.Text, 0);
  while memSearchMon.Lines.Count > iSrchMonMax do
    memSearchMon.Lines.Delete(memSearchMon.Lines.Count - 1);
end;

procedure TfrmMain.chkSearchMonitorClick(Sender: TObject);
begin
  if not chkSearchMonitor.Checked then
    memSearchMon.Clear;
end;

procedure TfrmMain.btnDownloadClick(Sender: TObject);
begin
  pgcMain.ActivePage := tabDownloads;
end;

procedure TfrmMain.btnSearchClick(Sender: TObject);
begin
  iSrchResults := 0;
  lvwSrchRes.Items.Clear;
  UpdateSearchResultsCnt;
  gtt.BeginSearch(edtSearch.Text, StrToIntDef(edtMinSpeed.Text, 0));
end;

procedure TfrmMain.UpdateSearchResultsCnt;
begin
  lblSearchResults.Caption := IntToStr(iSrchResults) + ' item(s) found...';
  lblSearchResults.Visible := true;
end;

procedure TfrmMain.btnUpdateStatsClick(Sender: TObject);
begin
  gtt.ClearGTNStats;
  gtt.SendInitToAll;
end;

procedure TfrmMain.btnRemoveHostcatchClick(Sender: TObject);
begin
  if lstHostCatcher.ItemIndex <> -1 then
    lstHostCatcher.Items.Delete(lstHostCatcher.ItemIndex);
end;

procedure TfrmMain.btnClearHostCatchClick(Sender: TObject);
begin
  lstHostCatcher.Items.Clear;
end;

procedure TfrmMain.mniClearLogClick(Sender: TObject);
begin
  Memo1.Lines.Clear;
end;

procedure TfrmMain.edtSearchKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then begin
    btnSearchClick(nil);
    Key := #0;
  end;
end;

procedure TfrmMain.btnAddClick(Sender: TObject);
begin
  gtt.ConnectNewHost(edtHost.Text);
end;

procedure TfrmMain.LoadSettings;
begin
  with TINIFile.Create('.\gnutella.ini') do begin
    edtTryToKeep.Text := ReadString('gnutella', 'keepupnet', '4');
    chkAutoClearUL.Checked := ReadBool('gnutella', 'autoclearul', true);
    edtMaxDL.Text := ReadString('gnutella', 'maxdl', '2');
    chkAutoClearDL.Checked := ReadBool('gnutella', 'autocleardl', false);
    edtMinSpeed.Text := ReadString('gnutella', 'srch_minspeed', '0');
    chkSearchMonitor.Checked := ReadBool('gnutella', 'searchmon', true);
    edtSrchCount.Text := ReadString('gnutella', 'searchmon_num', '25');
    edtListenPort.Text := ReadString('gnutella', 'port', '6346');
    edtConnectionSpeed.Text := ReadString('gnutella', 'conspeed', '28');
    edtMaxTTL.Text := ReadString('gnutella', 'maxttl2', '7');
    edtMyTTL.Text := ReadString('gnutella', 'myttl2', '7');
    chkForceLocalIP.Checked := ReadBool('gnutella', 'forceip', false);
    edtLocalIP.Text := ''; 
    Free;
  end;
end;

procedure TfrmMain.UpdateOneConnectionInfo(CInfo : TGConnection;
  const Stat : string);
var
  I:  integer;
begin
  for I := 0 to lvwConnections.Items.Count - 1 do
    if CInfo.Host = lvwConnections.Items[I].Caption then begin
      if Stat = '' then
        lvwConnections.Items[I].Delete
      else
        lvwConnections.Items[I].SubItems[1] := Stat;
      exit;
    end;
end;

procedure TfrmMain.gttLogStatus(Sender: TObject; const s: String);
begin
  Log(s);
end;

procedure TfrmMain.gttClientCreated(CInfo: TGConnection);
begin
  with lvwConnections.Items.Add do begin
    Caption := CInfo.Host;
    if CInfo.Incoming then
      SubItems.Add('Incoming')
    else
      SubItems.Add('Outgoing');
    SubItems.Add('Connecting');
  end;
end;

procedure TfrmMain.gttClientConnected(CInfo: TGConnection);
begin
  UpdateOneConnectionInfo(CInfo, 'Connected');
end;

procedure TfrmMain.gttInitResponse(const HostIP: String; HostPort: Word;
  FileCnt, FileSize: Integer);
begin
  UpdateGTNStats;
end;

procedure TfrmMain.gttSearchReq(MinSpeed: Word; const Search: String);
begin
  if chkSearchMonitor.Checked then begin
    while memSearchMon.Lines.Count > iSrchMonMax do
      memSearchMon.Lines.Delete(memSearchMon.Lines.Count - 1);
    memSearchMon.Lines.Insert(0, Search);
  end;

//  edtSearches.Text := IntToStr(gtt.SearchesIn);
end;

procedure TfrmMain.gttSrchRespItem(FileIdx, FileSize, HostSpeed: Integer;
  const FileName: String);
begin
  with lvwSrchRes.Items.Add do begin
    Caption := FileName;
    SubItems.Add(IntToStr(FileSize));
    SubItems.Add(IntToStr(HostSpeed));
  end;
end;

procedure TfrmMain.gttClientDisconnect(CInfo: TGConnection);
begin
  UpdateOneConnectionInfo(CInfo, '');
  UpdateConnections;

  DoTryNKeep;
end;

procedure TfrmMain.tmrUpdteNetInfoTimer(Sender: TObject);
begin
  edtTotalMessages.Text := IntToStr(gtt.MessagesIn);
  edtSearches.Text := IntToStr(gtt.SearchesIn);
  edtRouteErrs.Text := IntToStr(gtt.RoutingErrorsIn);
  edtDropped.Text := IntToStr(gtt.MessagesDropped);
  edtUploadCnt.Text := IntToStr(gtt.FilesUploaded);
  edtDownloadCnt.Text := IntToStr(gtt.FilesDownloaded);
end;

procedure TfrmMain.btnUpdateListenPortClick(Sender: TObject);
begin
  gtt.CancelListen;
  gtt.ListenPort := StrToInt(edtListenPort.Text);
  if gtt.ListenPort <> 0 then
    gtt.Listen;
  lblCurrentPort.Caption := 'Current port: ' + IntToStr(gtt.ListenPort);
  btnUpdateListenPort.Enabled := false;
end;

procedure TfrmMain.edtListenPortChange(Sender: TObject);
begin
  btnUpdateListenPort.Enabled := true;
end;

procedure TfrmMain.edtConnectionSpeedChange(Sender: TObject);
begin
  gtt.ConnectionSpeed := StrToIntDef(edtConnectionSpeed.Text, 0);
end;

procedure TfrmMain.edtMaxTTLChange(Sender: TObject);
begin
  gtt.MaxTTL := StrToIntDef(edtMaxTTL.Text, 7);
end;

procedure TfrmMain.edtMyTTLChange(Sender: TObject);
begin
  gtt.MyTTL := StrToIntDef(edtMyTTL.Text, 7);
end;

procedure TfrmMain.edtLocalIPChange(Sender: TObject);
begin
  if chkForceLocalIP.Checked then
    gtt.LocalIP := edtLocalIP.Text;
end;

procedure TfrmMain.chkForceLocalIPClick(Sender: TObject);
begin
  if chkForceLocalIP.Checked then
    gtt.LocalIP := edtLocalIP.Text
  else
    gtt.LocalIP := '';
end;

procedure TfrmMain.gttClientProtocolConnect(CInfo: TGConnection);
begin
  UpdateConnections;
end;

procedure TfrmMain.gttCatchHost(Sender: TObject; const s: String);
begin
  if (Pos('192.168.', s) = 1) or
    (Pos('10.', s) = 1) or
    (s = '127.0.0.1') then
    exit;

  if lstHostCatcher.Items.IndexOf(s) = -1 then
    lstHostCatcher.Items.Add(s);
end;

procedure TfrmMain.gttListenPortInUse(Sender: TObject);
begin
  MessageDlg('The port you specified for listening (' +
    IntToStr(gtt.ListenPort) + ') is in use.  Listen will be diabled ' +
    'until a new port is selected.', mtInformation, [mbOK], 0);
end;

procedure TfrmMain.btnRemoveClientClick(Sender: TObject);
begin
  if Assigned(lvwConnections.Selected) then
    gtt.DisconnectHost(lvwConnections.Selected.Caption);
end;

procedure TfrmMain.DoTryNKeep;
begin
  if lstHostCatcher.Items.Count = 0 then
    exit;

  while gtt.SocketCount < StrToIntDef(edtTryToKeep.Text, 0) do
    gtt.ConnectNewHost(lstHostCatcher.Items[Random(lstHostCatcher.Items.Count)]);
end;

procedure TfrmMain.edtTryToKeepChange(Sender: TObject);
begin
  DoTryNKeep;
end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
  DoTryNKeep;
end;

end.

